﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Web;
using System.Net;
using XServer;

namespace TimeSnippet
{
    public partial class Form1 : Form
    {
        XMapWSService svcMap = new XMapWSService()
        {
            Url = Properties.Settings.Default.Url,
            Credentials = new System.Net.NetworkCredential(){
                UserName = Properties.Settings.Default.UserName,
                Password = Properties.Settings.Default.Password
            }
        };
        DateTime dt = DateTime.Now;

        public Form1()
        {
            InitializeComponent();
        }

        public void go() {
            
            MapSection mapSection = new MapSection()
            {
                center = new XServer.Point() { wkt = Properties.Settings.Default.Center },
                scale = Properties.Settings.Default.Scale
            };

            ImageInfo ii = new ImageInfo()
            {
                format = ImageFileFormat.PNG,
                height = pictureBox1.Height,
                width = pictureBox1.Width
            };

            CallerContextProperty ccpSnippet = new CallerContextProperty() {
                key = "ProfileXMLSnippet",
                //value = "&lt;Profile xmlns:xsi=&quot;http://www.w3.org/2001/XMLSchema-instance&quot; xsi:noNamespaceSchemaLocation=&quot;http:///xmap/schema/XMapProfile.xsd&quot;&gt; &lt;FeatureLayer majorVersion=&quot;1&quot; minorVersion=&quot;0&quot;&gt; &lt;GlobalSettings enableTimeDependency=&quot;true&quot;/&gt; &lt;Themes&gt; &lt;Theme enabled=&quot;true&quot; id=&quot;PTV_SpeedPatterns&quot;/&gt; &lt;/Themes&gt; &lt;/FeatureLayer&gt; &lt;/Profile&gt;"
                value = Properties.Settings.Default.ProfileXMLSnippet

                //System.IO.File.ReadAllText("C:\\PTV-xServer\\XRadio\\20150722-snippet\\xmap.puresnippet.xml")
            };
            //ccpSnippet.value = ccpSnippet.value.Replace("&gt;", ">").Replace("&lt", "<");
            //ccpSnippet.value = ccpSnippet.value.Replace("&quot;", "'");



            CallerContext cc = new CallerContext(){
                wrappedProperties = new CallerContextProperty[]{
                    ccpSnippet
                }
            };

            MapParams mapParams = new MapParams();
            DateTime referenceTime = Properties.Settings.Default.referenceTime;

            while (referenceTime <= Properties.Settings.Default.endTime)
            {
                mapParams.referenceTime = referenceTime.ToString("o");
                this.Text = mapParams.referenceTime;
                pictureBox1.Image = System.Drawing.Image.FromStream(new System.IO.MemoryStream(svcMap.renderMap(mapSection, mapParams, ii, null, true, cc).image.rawImage));
                pictureBox1.Show();
                pictureBox1.Update();
                System.Threading.Thread.Sleep(Properties.Settings.Default.Sleep);
                referenceTime = referenceTime.AddSeconds(Properties.Settings.Default.AddSeconds);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        public string formatDateTime(DateTime dt)
        {
            return dt.ToString("o");
        }


        private void pictureBox1_Click(object sender, EventArgs e)
        {
            go();
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {

        }
    }
}
